<?php
/*
Plugin Name:  Zy Coder
Plugin URI:   https://innovawer.com/zycoder/
Description:  Insert Files & Snippets of PHP|HTML|JS|CSS|CMD Code
Author:       Innovawer
Author URI:   https://innovawer.com
Version:      1.0.0
License:      GPL-2.0-or-later
License URI:  license.txt
Text Domain:  zycoder
Requires PHP: 5.6
Requires at least: 3.6
*/

function execCode($code, $typ, $glob=''){
    $ret='';
    $typ=strtolower($typ);
    ob_start();
    if($glob) eval($glob);
    if($typ=='js') $ret=eval("?>\n\n<script>".($code)."</script>\n\n<?php");
    else if($typ=='css') $ret=eval("?>\n\n<style>".$code."</style>\n\n<?php");
    else if($typ=='cmd'){
        $out=null;$rval=null;
        exec($code, $out, $rval);
        $ret=implode("\n", $out);
    }else if($typ=='php'){
        $op=strpos($code,'<?php');
        $cp=strpos($code,'?>');
        if($op!==false)
        if($op<$cp) $code="?>\n\n".$code."\n\n<?php";
        $ret=eval($code);
    }else $ret=eval("?>\n\n".$code."\n\n<?php");
    $ret.=ob_get_clean();
    return $ret;
}
function execFile($file, $glob=''){
    $code=file_get_contents($file);
    $ext=substr(strrchr($file, '.'), 1);
    return execCode($code, $ext, $glob);
}
add_shortcode('zy', 'doZy');
function doZy($atts, $content){
    $ret='';
    $glob='';
    if($atts['gvar']) $glob='global '.$atts['gvar'].';';
    if($atts['file']) $ret.=execFile($atts['file'], $glob);
    if($atts['path']) $ret.=execFile($atts['path'], $glob);
    if($content) $ret.=execCode($content, $atts['code'], $glob);
    
    if($atts['shortcodes']){
		remove_shortcode('zy');
		$ret = do_shortcode($ret);
		add_shortcode('zy', 'doZy');
	}
	
    return $ret;
}

$loadCode='iw/zy-load.php';
if(file_exists($loadCode)) include_once($loadCode);
//add_shortcode('', [ $this, 'render_source_shortcode' ] );

?>